export abstract class Joke {
    private _type: string;
    private _setup: string;
    private _punchline: string;
    private _image: string;

    constructor(type: string, setup: string, punchline: string, image: string) {
        this._type = type;
        this._setup = setup;
        this._punchline = punchline;
        this._image = image;
    }

    public get type() {
        return this._type;
    }
    public get setup():string {
        return this._setup;
    }
    public get punchline():string {
        return this._punchline;
    }
    public get image():string {
        return this._image;
    }
    public set type(theType:string) {
        this._type = theType;
    }
    public set setup(theSetup: string) {
        this._setup = theSetup;
    }
    public set punchline(thePunchline:string) {
        this._punchline = thePunchline;
    }
    public set image(theImage:string) {
        this._image = theImage;
    }
    public summary(): string {
        return this.punchline.substring(0,24) + "...";
    }
    public description(): string {
        return this.type + this.summary;
    }
}