import { CustomJoke } from "./CustomJoke";
import { SampleJoke } from "./SampleJoke";

export class JokeFactory {
    public static createCustomJokes(jsonArray: string): CustomJoke[] {
        const jsonObjects: any[] = JSON.parse(jsonArray);
        const customJokes: CustomJoke[] = [];

        for (const jsonObject of jsonObjects) {
            const customJoke: CustomJoke = new CustomJoke(
                jsonObject.id,
                jsonObject.type,
                jsonObject.setup,
                jsonObject.punchline,
                jsonObject.image
            );
            customJokes.push(customJoke);
        }

        return customJokes;
    }

    public static createSampleJokes(jsonArray: string): SampleJoke[] {
        const jsonObjects: any[] = JSON.parse(jsonArray);
        const sampleJokes: SampleJoke[] = [];

        for (const jsonObject of jsonObjects) {
            const sampleJoke: SampleJoke = new SampleJoke(
                jsonObject.id,
                jsonObject.type,
                jsonObject.setup,
                jsonObject.punchline,
                jsonObject.image
            );
            sampleJokes.push(sampleJoke);
        }

        return sampleJokes;
    }
}